import os
from os.path import join
import glob
import datetime


def get_time():
    return datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")


def logger(text, log_file):
    with open(log_file, 'a') as result_file:
        result_file.write(f'{text}\n')


def get_curr_log_name(args):
    # log directory check, 参考：https://thispointer.com/how-to-create-a-directory-in-python/
    if not os.path.exists(args.log_dir):
        os.mkdir(args.log_dir)

    # 获取命令行里数据集路径里的文件名
    log_base = os.path.basename(args.dataset)
    # 把文件名的扩展去掉
    log_file_no_ext = os.path.splitext(log_base)[0]
    # 创建新的相关数据集的log文件
    curr_log_files = glob.glob(join(args.log_dir, log_file_no_ext + '*.txt'))
    if len(curr_log_files) != 0:
        file_names = [os.path.basename(name) for name in curr_log_files]
        file_names_no_ext = [os.path.splitext(name)[0] for name in file_names]
        # 用split而不用partition的原因见：https://www.quora.com/Whats-the-difference-between-partition-and-split-for-strings-in-Python
        nums = [int(name.split('_')[-1]) for name in file_names_no_ext]
        nums.sort()
        max = nums[-1]
        log_file = join(args.log_dir, f'{log_file_no_ext}_{max + 1}.txt')
    else:
        log_file = join(args.log_dir, f'{log_file_no_ext}_0.txt')

    return log_file
